module MaxPlus where

import Polynomial

-- max{p1, ..., pn}
type MaxPlus = [Polynomial]

var :: String -> MaxPlus
var x = [ Polynomial.var x ]

num :: Int -> MaxPlus
num n = [ Polynomial.num n ]

-- unfold max
flatten :: [MaxPlus] -> MaxPlus
flatten mps = concat mps

plus :: Int -> MaxPlus -> MaxPlus
plus k ps = [Polynomial.plus [(Polynomial.num k), p] | p <- ps]

times :: Int -> MaxPlus -> MaxPlus
times k ps = [ Polynomial.times k p | p <- ps]

-- max G >= max H
geq :: MaxPlus -> MaxPlus -> Bool
geq gs hs = all (\h -> (any (\g -> Polynomial.geq g h) gs)) hs

-- max G > max H
gt :: MaxPlus -> MaxPlus -> Bool
gt gs hs = all (\h -> (any (\g -> Polynomial.gt g h) gs)) hs
