module ReplacementMap where

import Data.List

-- (f, n, [i_1,...,i_m]) means mu(f^(n)) = {i_1,...,i_m}.
type Binding = (String,Int,[Int])

type ReplacementMap = [Binding]

showBinding :: Binding -> String
showBinding (f, _, is) =
  f ++ " : {" ++ intercalate "," [ show i | i <- is ] ++ "}"

showReplacementMap :: ReplacementMap -> String
showReplacementMap mu = unlines [ showBinding b | b <- mu ]

complementBinding :: Binding -> Binding
complementBinding (f, n, is) =
  (f, n, [ i | i <- [0 .. n-1], notElem i is ])

complement :: ReplacementMap -> ReplacementMap
complement mu = [ complementBinding b | b <- mu ]